var Proxy = require("./lib/proxy"), ERR = require("./lib/server_errs"), jsProcessor = require("./shared/js_processor"), CLIENT_ERR = require("./shared/client_errs");

var Hammerhead = module.exports.Hammerhead = function(port, hostname, options) {
    var staticResources = options ? options.staticResources : {};
    this.proxy = new Proxy(port, hostname, staticResources);
    this.staticCssUrl = this.proxy.staticCssUrl;
    this.staticScriptUrl = this.proxy.staticScriptUrl;
    this.hammerheadScriptUrl = this.proxy.hammerheadScriptUrl;
    this.serviceEvents = this.proxy.serviceEvents;
    this.proxyEvents = this.proxy.proxyEvents;
    this.SERVER_ERRS = ERR;
};

exports.SERVER_ERRS = ERR;

exports.CLIENT_ERRS = CLIENT_ERR;

Hammerhead.prototype.start = function() {
    this.proxy.start();
};

Hammerhead.prototype.close = function() {
    this.proxy.close();
};

Hammerhead.prototype.getProxyUrl = function() {
    return this.proxy.getProxyUrl.apply(this.proxy, arguments);
};

Hammerhead.prototype.getSettingsScript = function() {
    return this.proxy.getSettingsScript.apply(this.proxy, arguments);
};

Hammerhead.prototype.removeCookies = function() {
    return this.proxy.removeCookies.apply(this.proxy, arguments);
};

exports.wrapDomAccessors = function(code) {
    return jsProcessor.process(code);
};