var CookieShelf = require("./cookie_shelf"), ServiceChannel = require("./service_channel"), Server = require("./server");

var Proxy = module.exports = function(port, hostname, staticResources) {
    this.cookieShelf = new CookieShelf();
    this.serviceChannel = new ServiceChannel(port, hostname, this.cookieShelf, staticResources);
    this.server = new Server(port, hostname, this.cookieShelf, this.serviceChannel);
    this.serviceMsgUrl = this.serviceChannel.serviceMsgUrl;
    this.staticCssUrl = this.serviceChannel.staticCssUrl;
    this.staticScriptUrl = this.serviceChannel.staticScriptUrl;
    this.hammerheadScriptUrl = this.serviceChannel.hammerheadScriptUrl;
    this.serviceEvents = this.serviceChannel.events;
    this.proxyEvents = this.server.events;
};

Proxy.prototype.start = function() {
    this.server.start();
};

Proxy.prototype.close = function() {
    this.server.close();
};

Proxy.prototype.getProxyUrl = function() {
    return this.server.getProxyUrl.apply(this.server, arguments);
};

Proxy.prototype.removeCookies = function() {
    return this.cookieShelf.removeCookies.apply(this.cookieShelf, arguments);
};

Proxy.prototype.getSettingsScript = function(ctx) {
    var serviceChannel = this.serviceChannel;
    return serviceChannel.getSettingsScript({
        jobUid: ctx.jobInfo.uid,
        jobOwnerToken: ctx.jobInfo.ownerToken,
        serviceMsgUrl: serviceChannel.serviceMsgUrl,
        originHost: ctx.originResourceInfo.host,
        originProtocol: ctx.originResourceInfo.protocol,
        originHostname: ctx.originResourceInfo.hostname,
        originPort: ctx.originResourceInfo.port,
        cookie: "",
        taskScript: ""
    });
};