(function() {
    var isNode = typeof module !== "undefined" && module.exports, baseUrl = "";
    var UrlUtil = {}, SharedErrors = null;
    UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY = "7929ba6d39aa4465";
    UrlUtil.REQUEST_DESCRIPTOR_VALUES_SEPARATOR = "|";
    UrlUtil.QUESTION_MARKS_REPLACE_VALUE = "_99a04510-4752-4ac3-9382-241cbdf30d55-";
    UrlUtil.DOCUMENT_URL_RESOLVER = "doc_url_resolver_8ff20d5e";
    if (isNode) {
        module.exports = UrlUtil;
    } else {
        HammerheadClient.define("Shared.UrlUtil", function(require) {
            var Settings = require("Settings");
            SharedErrors = require("Shared.Errors");
            UrlUtil.getProxyUrl = function(url, proxyHostname, proxyPort, jobUid, jobOwnerToken, isIFrame) {
                if (!UrlUtil.isSupportedProtocol(url)) {
                    return url;
                }
                url = UrlUtil.resolveUrl(url);
                var isCompletedProxyUrl = UrlUtil.parseProxyUrl(url);
                proxyHostname = proxyHostname || location.hostname;
                proxyPort = proxyPort || location.port.toString();
                jobUid = jobUid || Settings.JOB_UID;
                jobOwnerToken = jobOwnerToken || Settings.JOB_OWNER_TOKEN;
                if (!isCompletedProxyUrl) {
                    var parsedUrl = UrlUtil.parseUrl(url);
                    if (parsedUrl.host === location.host && parsedUrl.protocol === location.protocol) {
                        var query = [ Settings.ORIGIN_URL_OBJ.protocol, Settings.ORIGIN_URL_OBJ.host, jobUid, jobOwnerToken ];
                        if (isIFrame) {
                            query.push(isIFrame);
                        }
                        parsedUrl.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY] = query.join(UrlUtil.REQUEST_DESCRIPTOR_VALUES_SEPARATOR);
                        return UrlUtil.formatUrl(parsedUrl);
                    }
                } else {
                    return url;
                }
                return getProxyUrlCore(url, proxyHostname, proxyPort, jobUid, jobOwnerToken, isIFrame);
            };
            UrlUtil.getOriginUrlObj = function(proxyUrl) {
                proxyUrl = proxyUrl || location.toString();
                var parsedProxyUrl = UrlUtil.parseProxyUrl(proxyUrl), parsedUrl = UrlUtil.parseUrl(proxyUrl), query = proxyUrl ? parsedUrl.query : UrlUtil.parseQuery(location.search), result = {};
                result.protocol = parsedProxyUrl ? parsedProxyUrl.originResourceInfo.protocol : Settings.ORIGIN_URL_OBJ.protocol;
                result.port = parsedProxyUrl ? parsedProxyUrl.originResourceInfo.port : Settings.ORIGIN_URL_OBJ.port;
                result.hostname = parsedProxyUrl ? parsedProxyUrl.originResourceInfo.hostname : Settings.ORIGIN_URL_OBJ.hostname;
                result.host = parsedProxyUrl ? parsedProxyUrl.originResourceInfo.host : Settings.ORIGIN_URL_OBJ.host;
                result.pathname = parsedUrl.pathname;
                result.hash = parsedUrl.hash;
                result.query = query;
                if (result.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY]) {
                    delete result.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY];
                }
                result.search = UrlUtil.formatQuery(result.query);
                return result;
            };
            this.exports = UrlUtil;
        });
    }
    if (isNode) {
        (function() {
            var url = require("url");
            SharedErrors = require("./client_errs");
            UrlUtil.parseUrl = function(urlStr, locationProtocol) {
                var decodeFunc = decodeURIComponent, replaceFunc = String.prototype.replace, urlWithoutProtocol = urlStr.indexOf("//") === 0;
                decodeURIComponent = function(comp) {
                    return comp;
                };
                String.prototype.replace = function(regexp, string) {
                    var unallowed = regexp.toString() === "/\\+/g" && string === "%20";
                    return unallowed ? this : replaceFunc.apply(this, arguments);
                };
                if (urlWithoutProtocol && locationProtocol) {
                    urlStr = locationProtocol + urlStr;
                }
                var result = url.parse(urlStr, true), desc = result.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY];
                String.prototype.replace = replaceFunc;
                decodeURIComponent = decodeFunc;
                if (desc) {
                    var decodedDesc = decodeURIComponent(desc);
                    result.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY] = decodedDesc;
                    result.path = result.path.replace(desc, decodedDesc);
                    result.search = result.search.replace(desc, decodedDesc);
                    result.href = result.href.replace(desc, decodedDesc);
                }
                return result;
            };
            UrlUtil.formatUrl = function(urlObj, urlSrc) {
                var encodeFunc = encodeURIComponent;
                encodeURIComponent = function(comp) {
                    if (urlObj.query && urlObj.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY] === comp) {
                        return encodeFunc(comp);
                    }
                    return comp;
                };
                var result = url.format(urlObj);
                encodeURIComponent = encodeFunc;
                if (urlSrc) {
                    result = UrlUtil.cleanEmptyParams(result, urlSrc);
                }
                return result;
            };
        })();
    } else {
        (function() {
            var SLASHED_PROTOCOLS = {
                "http:": true,
                "https:": true,
                "ftp:": true,
                "gopher:": true,
                "file:": true
            }, URL_REGEXP = /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?(([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/;
            document[UrlUtil.DOCUMENT_URL_RESOLVER] = document.createElement("a");
            UrlUtil.resolveUrl = function(url, doc) {
                var urlResolver = (doc || document)[UrlUtil.DOCUMENT_URL_RESOLVER];
                if (url === null) {
                    urlResolver.removeAttribute("href");
                } else {
                    urlResolver.href = url;
                }
                return urlResolver.href;
            };
            UrlUtil.parseUrl = function(urlStr) {
                if (urlStr) {
                    var isRelativePath = !/(^(\s)*(\w)+\:)|(^(\s)*\/\/)/.test(urlStr);
                    if (isRelativePath && urlStr.indexOf("/") !== 0) {
                        urlStr = "/" + urlStr;
                    }
                }
                var urlParts = URL_REGEXP.exec(urlStr), urlObj = {
                    protocol: urlParts[1] ? urlParts[1] + ":" : "",
                    host: urlParts[2] || "",
                    hostname: urlParts[3] || "",
                    port: urlParts[4] || "",
                    pathname: urlParts[6] || "",
                    query: {},
                    hash: urlParts[10] ? "#" + urlParts[10] : ""
                };
                if (urlParts[9]) {
                    var queryKeyValueStrs = urlParts[9].split("&");
                    for (var i = 0; i < queryKeyValueStrs.length; i++) {
                        var keyValue = queryKeyValueStrs[i].split("="), key = keyValue[0], val = queryKeyValueStrs[i].substr(key.length + 1);
                        if (key) {
                            if (key === UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY) {
                                val = decodeURIComponent(val);
                            }
                            if (!urlObj.query.hasOwnProperty(key)) {
                                urlObj.query[key] = val;
                            } else {
                                if (Object.prototype.toString.call(urlObj.query[key]) === "[object Array]") {
                                    urlObj.query[key].push(val);
                                } else {
                                    urlObj.query[key] = [ urlObj.query[key], val ];
                                }
                            }
                        }
                    }
                }
                return urlObj;
            };
            UrlUtil.formatUrl = function(urlObj) {
                var protocol = urlObj.protocol || "";
                if (protocol && protocol.charAt(protocol.length - 1) !== ":") {
                    protocol += ":";
                }
                var host = urlObj.host || "";
                if (!host && urlObj.hostname) {
                    host = urlObj.hostname;
                    if (urlObj.port) {
                        host += ":" + urlObj.port;
                    }
                }
                var pathname = urlObj.pathname ? urlObj.pathname.replace(/[?#]/g, function(match) {
                    return encodeURIComponent(match);
                }) : "";
                if (host && (!protocol || SLASHED_PROTOCOLS[protocol] > -1)) {
                    host = "//" + host;
                    if (pathname && pathname.charAt(0) !== "/") {
                        pathname = "/" + pathname;
                    }
                }
                var search = "";
                if (urlObj.query) {
                    var queryKeyValues = [], add = function(key, val) {
                        if (key === UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY) {
                            val = encodeURIComponent(val);
                        }
                        if (key) {
                            queryKeyValues.push(key + (val ? "=" + val : ""));
                        }
                    };
                    for (var key in urlObj.query) {
                        if (urlObj.query.hasOwnProperty(key)) {
                            var val = urlObj.query[key];
                            if (Object.prototype.toString.call(val) === "[object Array]") {
                                for (var i = 0; i < val.length; i++) {
                                    add(key, val[i]);
                                }
                            } else {
                                add(key, val);
                            }
                        }
                    }
                    if (queryKeyValues.length) {
                        search = "?" + queryKeyValues.join("&");
                    }
                }
                search = search.replace("#", "%23");
                var hash = urlObj.hash || "";
                if (hash && hash.charAt(0) !== "#") {
                    hash = "#" + hash;
                }
                return protocol + host + pathname + search + hash;
            };
        })();
    }
    UrlUtil.executeWithBaseUrl = function(url, action) {
        baseUrl = url;
        action();
        baseUrl = "";
    };
    UrlUtil.getBaseUrl = function() {
        return baseUrl;
    };
    UrlUtil.isSupportedProtocol = function(url) {
        return !/(^javascript:)|(^about:)|(^mailto:)|(^tel:)|(^data:)|(^skype:)|(^file:)|(^#)/i.test(url);
    };
    UrlUtil.parseQuery = function() {
        var params = location.search.substr(1).split("&"), query = {};
        for (var i = 0; i < params.length; i++) {
            var name = params[i].match(/[^=]*/)[0], valueMatch = params[i].match(/=(.*)$/), value = valueMatch ? valueMatch[1] : null;
            query[name] = value;
        }
        return query;
    };
    UrlUtil.sameOriginCheck = function(location, checkedUrl) {
        if (!checkedUrl) {
            return true;
        }
        if (!isNode) {
            checkedUrl = UrlUtil.resolveUrl(checkedUrl);
        }
        var parsedLocation = UrlUtil.parseUrl(location), parsedCheckedUrl = UrlUtil.parseUrl(checkedUrl, parsedLocation.protocol), parsedProxyLocation = UrlUtil.parseProxyUrl(location), parsedOriginUrl = parsedProxyLocation ? parsedProxyLocation.originResourceInfo : null, isRelative = !parsedCheckedUrl.host;
        var isSubDomain = function(domain, subDomain) {
            var index = subDomain.lastIndexOf(domain);
            return subDomain[index - 1] === "." && subDomain.length === index + domain.length;
        };
        if (isRelative || parsedCheckedUrl.host === parsedLocation.host && parsedCheckedUrl.protocol === parsedLocation.protocol) {
            return true;
        }
        if (parsedOriginUrl) {
            var portsEq = !parsedOriginUrl.port && !parsedCheckedUrl.port || parsedOriginUrl.port.toString() === parsedCheckedUrl.port;
            if (parsedOriginUrl.protocol === parsedCheckedUrl.protocol && portsEq) {
                if (parsedOriginUrl.hostname === parsedCheckedUrl.hostname) {
                    return true;
                }
                return isSubDomain(parsedOriginUrl.hostname, parsedCheckedUrl.hostname) || isSubDomain(parsedCheckedUrl.hostname, parsedOriginUrl.hostname);
            }
        }
        return false;
    };
    UrlUtil.formatQuery = function(query) {
        var params = [];
        for (var key in query) {
            if (query.hasOwnProperty(key)) {
                params.push(key + (query[key] ? "=" + query[key] : ""));
            }
        }
        return "?" + params.join("&");
    };
    UrlUtil.changeProxyUrl = function(url, prop, value) {
        var parsedUrl = UrlUtil.parseUrl(url), parsedProxyUrl = UrlUtil.parseProxyUrl(url), newQuery = null;
        if (parsedProxyUrl) {
            var descr = [];
            if (prop === "search") {
                newQuery = UrlUtil.parseQuery(value);
                newQuery[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY] = parsedUrl[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY];
                parsedUrl.query = newQuery;
            }
            descr.push(prop === "protocol" ? value : parsedProxyUrl.originResourceInfo.protocol);
            if (prop === "hostname") {
                descr.push(value);
            } else {
                if (prop === "host") {
                    descr.push(prop + ":" + parsedProxyUrl.originResourceInfo.port);
                } else {
                    if (prop === "port") {
                        descr.push(parsedProxyUrl.originResourceInfo.hostname + ":" + value);
                    } else {
                        descr.push(parsedProxyUrl.originResourceInfo.host);
                    }
                }
            }
            descr.push(parsedProxyUrl.jobInfo.uid);
            descr.push(parsedProxyUrl.jobInfo.ownerToken);
            newQuery = descr.join(UrlUtil.REQUEST_DESCRIPTOR_VALUES_SEPARATOR);
            parsedUrl.query[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY] = newQuery;
            if (prop === "hash") {
                parsedUrl.hash = value;
            } else {
                if (prop === "pathname") {
                    parsedUrl.pathname = value;
                }
            }
            return UrlUtil.formatUrl(parsedUrl);
        }
        return url;
    };
    UrlUtil.convertToProxyUrl = function(url, isIFrame) {
        return UrlUtil.getProxyUrl(url, null, null, null, null, isIFrame);
    };
    function getProxyUrlCore(url, proxyHostname, proxyPort, jobUid, jobOwnerToken, isIFrame) {
        url = url.replace(/\?{2,}/g, function(match) {
            return UrlUtil.QUESTION_MARKS_REPLACE_VALUE + match.length + "_";
        });
        var parsedOriginUrl = UrlUtil.parseUrl(url), originQuery = parsedOriginUrl.query;
        if (parsedOriginUrl.protocol !== "http:" && parsedOriginUrl.protocol !== "https:") {
            throw {
                code: SharedErrors.URL_UTIL_PROTOCOL_IS_NOT_SUPPORTED,
                originUrl: url
            };
        }
        var query = [ parsedOriginUrl.protocol, parsedOriginUrl.host, jobUid, jobOwnerToken ];
        if (isIFrame) {
            query.push(isIFrame);
        }
        originQuery[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY] = query.join(UrlUtil.REQUEST_DESCRIPTOR_VALUES_SEPARATOR);
        return UrlUtil.formatUrl({
            protocol: "http:",
            port: proxyPort,
            hostname: proxyHostname,
            pathname: parsedOriginUrl.pathname,
            query: originQuery,
            hash: parsedOriginUrl.hash
        }, url);
    }
    UrlUtil.getProxyUrl = getProxyUrlCore;
    UrlUtil.parseProxyUrl = function(proxyUrl) {
        var parsedProxyUrl = UrlUtil.parseUrl(proxyUrl), proxyQuery = parsedProxyUrl.query, descriptor = proxyQuery[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY];
        if (!descriptor) {
            return;
        }
        try {
            descriptor = decodeURIComponent(descriptor);
        } catch (e) {
            return;
        }
        var descriptorValues = descriptor.split(UrlUtil.REQUEST_DESCRIPTOR_VALUES_SEPARATOR);
        var originProtocol = descriptorValues[0], originHost = descriptorValues[1], jobUid = descriptorValues[2], jobOwnerToken = descriptorValues[3], isIFrame = descriptorValues.length > 4 ? descriptorValues[4] : false;
        if (!originHost || !originProtocol) {
            return;
        }
        delete proxyQuery[UrlUtil.REQUEST_DESCRIPTOR_QUERY_KEY];
        var originHostParts = originHost.split(":");
        parsedProxyUrl.pathname = parsedProxyUrl.pathname.replace(new RegExp(UrlUtil.QUESTION_MARKS_REPLACE_VALUE + "(\\d+)_", "g"), function(match) {
            var matchLength = /(\d+)_/.exec(match)[1], replacedValue = "";
            for (var i = 0; i < matchLength; i++) {
                replacedValue += "?";
            }
            return replacedValue;
        });
        return {
            originResourceInfo: {
                protocol: originProtocol,
                host: originHost,
                hostname: originHostParts[0],
                port: originHostParts[1] || "",
                pathname: parsedProxyUrl.pathname,
                query: proxyQuery,
                hash: parsedProxyUrl.hash
            },
            jobInfo: {
                uid: jobUid,
                ownerToken: jobOwnerToken
            },
            isIFrame: isIFrame
        };
    };
    UrlUtil.cleanEmptyParams = function(url, originUrl) {
        var cleanedUrl = url, originQuery = UrlUtil.parseUrl(url).query, escapeRegExp = function(str) {
            return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
        };
        Object.keys(originQuery).forEach(function(param) {
            if (param && !originQuery[param]) {
                var emptyParamRegEx = new RegExp(escapeRegExp(param) + "=(&|$)");
                if (!emptyParamRegEx.test(originUrl)) {
                    cleanedUrl = cleanedUrl.replace(param + "=", param);
                }
            }
        });
        return cleanedUrl;
    };
})();